diff -ruN ../nakedmudv3.3/src/room_reset.c src/room_reset.c
--- ../nakedmudv3.3/src/room_reset.c	2006-12-24 22:15:56.000000000 -0500
+++ src/room_reset.c	2007-09-22 22:36:11.000000000 -0400
@@ -33,6 +33,8 @@
 #include "items/container.h"
 #include "items/furniture.h"
 #include "items/worn.h"
+#include "scripts/scripts.h"
+#include "scripts/pyplugs.h"
 
 
 
@@ -117,7 +119,7 @@
   int      chance; // what is our chance of success?
   int         max; // what is the max number of us that can be in the game?
   int    room_max; // what is the max number of us that can be in the room?
-  char       *arg; // what is our reset arg (e.g. mob proto, direction name)
+  BUFFER     *arg; // what is our reset arg (e.g. mob proto, direction name)
   LIST        *in; // what resets do we put into ourself?
   LIST        *on; // what resets do we put onto ourself?
   LIST      *then; // if this succeeds, what else do we do?
@@ -133,7 +135,8 @@
   "open exit or object",
   "close exit or object",
   "lock exit or object",
-  "change mobile position"
+  "change mobile position",
+  "run script"
 };
 
 
@@ -145,7 +148,7 @@
 RESET_DATA    *newReset         () {
   RESET_DATA *reset = calloc(1, sizeof(RESET_DATA));
   reset->type     = RESET_LOAD_OBJECT;
-  reset->arg      = strdup("");
+  reset->arg      = newBuffer(1);
   reset->times    = 1;
   reset->chance   = 100;
   reset->max      = 0;
@@ -162,7 +165,7 @@
   deleteListWith(reset->in,   deleteReset);
   deleteListWith(reset->on,   deleteReset);
   deleteListWith(reset->then, deleteReset);
-  if(reset->arg) free(reset->arg);
+  deleteBuffer(reset->arg);
   free(reset);
 }
 
@@ -200,7 +203,7 @@
   store_int   (set, "chance",   reset->chance);
   store_int   (set, "max",      reset->max);
   store_int   (set, "room_max", reset->room_max);
-  store_string(set, "arg",      reset->arg);
+  store_string(set, "arg",      bufferString(reset->arg));
   store_list  (set, "in",       gen_store_list(reset->in,   resetStore));
   store_list  (set, "on",       gen_store_list(reset->on,   resetStore));
   store_list  (set, "then",     gen_store_list(reset->then, resetStore));
@@ -215,10 +218,11 @@
   reset->chance   = read_int(set, "chance");
   reset->max      = read_int(set, "max");
   reset->room_max = read_int(set, "room_max");
-  reset->arg      = strdup(read_string(set, "arg"));
   reset->on       = gen_read_list(read_list(set, "on"),   resetRead);
   reset->in       = gen_read_list(read_list(set, "in"),   resetRead);
   reset->then     = gen_read_list(read_list(set, "then"), resetRead);
+  reset->arg = newBuffer(1);
+  bufferCat(reset->arg, read_string(set, "arg"));
   return reset;
 }
 
@@ -244,6 +248,10 @@
 }
 
 const char    *resetGetArg      (const RESET_DATA *reset) {
+  return bufferString(reset->arg);
+}
+
+BUFFER *resetGetArgBuffer       (const RESET_DATA *reset) {
   return reset->arg;
 }
 
@@ -280,8 +288,8 @@
 }
 
 void           resetSetArg      (RESET_DATA *reset, const char *arg) {
-  if(reset->arg) free(reset->arg);
-  reset->arg = strdupsafe(arg);
+  bufferClear(reset->arg);
+  bufferCat(reset->arg, arg);
 }
 
 void           resetAddOn       (RESET_DATA *reset, RESET_DATA *on) {
@@ -651,6 +659,41 @@
   return try_reset_opening(reset, initiator, initiator_type, TRUE, TRUE);
 }
 
+//
+// Try running a script on the initiator
+bool try_reset_script(RESET_DATA *reset, void *initiator, int initiator_type,
+		      const char *locale) {
+  PyObject *pyme = NULL;
+  PyObject *dict = NULL;
+  if(initiator_type == INITIATOR_ROOM)
+    pyme = roomGetPyFormBorrowed(initiator);
+  else if(initiator_type == INITIATOR_THEN_OBJ)
+    pyme = objGetPyFormBorrowed(initiator);
+  else if(initiator_type == INITIATOR_THEN_MOB)
+    pyme = charGetPyFormBorrowed(initiator);
+  else
+    return FALSE;
+
+  // build our dictionary and add ourself to it as 'me'
+  dict = restricted_script_dict();
+  PyDict_SetItemString(dict, "me", pyme);
+
+  // run the script
+  run_script(dict, resetGetArg(reset), locale);
+
+  // check to see if we had an error
+  if(!last_script_ok()) {
+    char *tb = getPythonTraceback();
+    log_string("Reset script in locale %s terminated with an error:\r\n%s\r\n"
+	       "\r\nTraceback is:\r\n%s\r\n", 
+	       locale, resetGetArg(reset), tb);
+    free(tb);
+  }
+
+  // garbage collection and return our outcome
+  Py_DECREF(dict);
+  return last_script_ok();
+}
 
 //
 // run the reset data
@@ -698,6 +741,9 @@
     case RESET_POSITION:
       ret_val = try_reset_position(reset, initiator, initiator_type);
       break;
+    case RESET_SCRIPT:
+      ret_val = try_reset_script(reset, initiator, initiator_type, locale);
+      break;
     default:
       return FALSE;
     }
diff -ruN ../nakedmudv3.3/src/room_reset.h src/room_reset.h
--- ../nakedmudv3.3/src/room_reset.h	2006-12-24 22:15:56.000000000 -0500
+++ src/room_reset.h	2007-09-22 22:36:11.000000000 -0400
@@ -29,7 +29,8 @@
 #define RESET_CLOSE           7 // close an exit/object
 #define RESET_LOCK            8 // lock an exit/object
 #define RESET_POSITION        9 // change the position of a mobile
-#define NUM_RESETS           10
+#define RESET_SCRIPT         10 // run a script on the initiator
+#define NUM_RESETS           11
 
 
 // must be called before room resets are usable. Attaches a reset hook
@@ -50,6 +51,7 @@
 int            resetGetMax      (const RESET_DATA *reset);
 int            resetGetRoomMax  (const RESET_DATA *reset);
 const char    *resetGetArg      (const RESET_DATA *reset);
+BUFFER        *resetGetArgBuffer(const RESET_DATA *reset);
 LIST          *resetGetOn       (const RESET_DATA *reset);
 LIST          *resetGetIn       (const RESET_DATA *reset);
 LIST          *resetGetThen     (const RESET_DATA *reset);
diff -ruN ../nakedmudv3.3/src/scripts/pyauxiliary.c src/scripts/pyauxiliary.c
--- ../nakedmudv3.3/src/scripts/pyauxiliary.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pyauxiliary.c	2007-09-22 22:36:11.000000000 -0400
@@ -50,7 +50,7 @@
 }
 
 void deletePyAuxiliaryData(PyObject *data) {
-  Py_DECREF(data);
+  Py_XDECREF(data);
 }
 
 void pyAuxiliaryDataCopyTo(PyObject *from, PyObject *to) {
diff -ruN ../nakedmudv3.3/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.3/src/scripts/pychar.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pychar.c	2007-09-22 22:36:11.000000000 -0400
@@ -38,7 +38,7 @@
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
-#include "../char_vars/char_vars.h"
+#include "../dyn_vars/dyn_vars.h"
 #include "../items/items.h"
 #include "../items/worn.h"
 
@@ -106,6 +106,10 @@
     return 1;
 }
 
+long PyChar_Hash(PyChar *ch) {
+  return ch->uid;
+}
+
 
 
 //*****************************************************************************
@@ -246,6 +250,12 @@
   else           return NULL;
 }
 
+PyObject *PyChar_getclass(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) return Py_BuildValue("s", charGetClass(ch));
+  else           return NULL;
+}
+
 PyObject *PyChar_getinv(PyChar *self, PyObject *args) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch == NULL) 
@@ -703,19 +713,28 @@
   }
 
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
-  if(ch) {
+
+  // we don't exist
+  if(ch == NULL) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Nonexistant character, %d, tried to perform an action.", 
+		    self->uid);
+    return NULL;
+  }
+  // It's not safe to act if we don't have a room to act in yet
+  else if(charGetRoom(ch) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Character, %d, tried to act without first having a room "
+		 "to act in.", self->uid);
+    return NULL;
+  }
+  else {
     // do not send the actual act - if we edit it, things go awry
     char *working_act = strdupsafe(act);
     do_cmd(ch, working_act, alias_ok);
     free(working_act);
     return Py_BuildValue("i", 1);
   }
-  else {
-    PyErr_Format(PyExc_TypeError, 
-                    "Nonexistant character, %d, tried to perform an action.", 
-		    self->uid);
-    return NULL;
-  }
 }
 
 
@@ -822,11 +841,11 @@
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch != NULL) {
     int vartype = charGetVarType(ch, var);
-    if(vartype == CHAR_VAR_INT)
+    if(vartype == DYN_VAR_INT)
       return Py_BuildValue("i", charGetInt(ch, var));
-    else if(vartype == CHAR_VAR_LONG)
+    else if(vartype == DYN_VAR_LONG)
       return Py_BuildValue("i", charGetLong(ch, var));
-    else if(vartype == CHAR_VAR_DOUBLE)
+    else if(vartype == DYN_VAR_DOUBLE)
       return Py_BuildValue("d", charGetDouble(ch, var));
     else
       return Py_BuildValue("s", charGetString(ch, var));
@@ -876,7 +895,6 @@
   }
 }
 
-
 PyObject *PyChar_getbodypct(PyChar *self, PyObject *args) {
   char   *parts = NULL;
   CHAR_DATA *ch = NULL;
@@ -896,6 +914,7 @@
   return Py_BuildValue("d", bodyPartRatio(charGetBody(ch), parts));
 }
 
+
 //
 // equips a character with an item
 PyObject *PyChar_equip(PyChar *self, PyObject *args) {  
@@ -1266,7 +1285,7 @@
     0,                         /*tp_as_number*/
     0,                         /*tp_as_sequence*/
     0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
+    (hashfunc)PyChar_Hash,     /*tp_hash */
     0,                         /*tp_call*/
     0,                         /*tp_str*/
     0,                         /*tp_getattro*/
@@ -1569,7 +1588,7 @@
   PyChar_addGetSetter("objs", PyChar_getinv, NULL,
 		      "returns a list of objects in the char's inventory");
   PyChar_addGetSetter("eq",   PyChar_geteq,  NULL,
-		      "returns a list of the character's equipment");
+		      "returns a list of the character's equipment.");
   PyChar_addGetSetter("bodyparts", PyChar_getbodyparts, NULL,
 		      "Returns a list of the character's bodyparts");
   PyChar_addGetSetter("name", PyChar_getname, PyChar_setname,
@@ -1608,6 +1627,8 @@
 		      "the character's unique identification number");
   PyChar_addGetSetter("prototypes", PyChar_getprototypes, NULL,
 		      "The prototypes for a mobile");
+  PyChar_addGetSetter("mob_class", PyChar_getclass, NULL,
+		      "The main prototype of the mobile.");
   PyChar_addGetSetter("is_npc", PyChar_getisnpc, NULL,
 		      "Returns 1 if the char is an NPC, and 0 otherwise.");
   PyChar_addGetSetter("is_pc", PyChar_getispc, NULL,
diff -ruN ../nakedmudv3.3/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv3.3/src/scripts/pyevent.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pyevent.c	2007-09-22 22:36:11.000000000 -0400
@@ -14,6 +14,7 @@
 #include "../mud.h"
 #include "../event.h"
 
+#include "scripts.h"
 #include "pychar.h"
 #include "pyroom.h"
 #include "pyobj.h"
@@ -27,9 +28,19 @@
   PyObject *PyOwner = NULL;
   PyObject   *efunc = NULL;
   PyObject   *edata = NULL;
+  char       *otype = NULL;
 
   // make sure we parse everything before we call the function
-  if(PyArg_ParseTuple(tuple, "OOO", &PyOwner, &efunc, &edata)) {
+  if(PyArg_ParseTuple(tuple, "sOO", &otype, &efunc, &edata)) {
+    if(!strcasecmp(otype, "char"))
+      PyOwner = charGetPyFormBorrowed(owner);
+    else if(!strcasecmp(otype, "room"))
+      PyOwner = roomGetPyFormBorrowed(owner);
+    else if(!strcasecmp(otype, "obj"))
+      PyOwner = objGetPyFormBorrowed(owner);
+    else
+      PyOwner = Py_None;
+
     PyObject *ret = PyObject_CallFunction(efunc, "OOs", PyOwner, edata, arg);
     Py_XDECREF(ret);
   }
@@ -55,6 +66,7 @@
   char         *arg = NULL;    // the arg we will be supplying to the function
   double      delay = 0;       // how long the event delay is (in seconds)
   void       *owner = NULL;    // actual owner supplied to the event handler
+  char    otype[20];           // is the owner a char, room, obj, or None?
 
   // try to parse all of our values
   if(!PyArg_ParseTuple(args, "OdO|Os", &PyOwner, &delay, &efunc, &edata, &arg)){
@@ -71,14 +83,22 @@
   }
 
   // figure out what type of data our owner is
-  if(PyOwner == Py_None)
+  if(PyOwner == Py_None) {
     owner = Py_None;
-  else if(PyChar_Check(PyOwner))
+    sprintf(otype, "none");
+  }
+  else if(PyChar_Check(PyOwner)) {
     owner = PyChar_AsChar(PyOwner);
-  else if(PyRoom_Check(PyOwner))
+    sprintf(otype, "char");
+  }
+  else if(PyRoom_Check(PyOwner)) {
     owner = PyRoom_AsRoom(PyOwner);
-  else if(PyObj_Check(PyOwner))
+    sprintf(otype, "room");
+  }
+  else if(PyObj_Check(PyOwner)) {
     owner = PyObj_AsObj(PyOwner);
+    sprintf(otype, "obj");
+  }
   // invalid type
   else {
     PyErr_Format(PyExc_TypeError,
@@ -94,7 +114,7 @@
   
   // now, queue up the action
   start_func(owner, (int)(delay SECONDS), PyEvent_on_complete, NULL, 
-	     Py_BuildValue("OOO", PyOwner, efunc, edata), arg);
+	     Py_BuildValue("sOO", otype, efunc, edata), arg);
 
   // everything seems ok. exit normally
   return Py_BuildValue("i", 1);
diff -ruN ../nakedmudv3.3/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv3.3/src/scripts/pyobj.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pyobj.c	2007-09-22 22:36:11.000000000 -0400
@@ -33,6 +33,7 @@
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
+#include "../dyn_vars/dyn_vars.h"
 #include "../items/items.h"
 #include "../items/worn.h"
 
@@ -694,6 +695,118 @@
 }
 
 
+//
+// Returns TRUE if the obj has the given variable set
+PyObject *PyObj_hasvar(PyObj *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Obj variables must have string names.");
+    return NULL;
+  }
+
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL)
+    return Py_BuildValue("b", objHasVar(obj, var));
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant obj, %d",
+	       self->uid);
+  return NULL;
+}
+
+
+//
+// Delete the variable set on the obj with the specified name
+PyObject *PyObj_deletevar(PyObj *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Obj variables must have string names.");
+    return NULL;
+  }
+
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL) {
+    objDeleteVar(obj, var);
+    return Py_BuildValue("i", 1);
+  }
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant obj, %d",
+	       self->uid);
+  return NULL;
+}
+
+
+//
+// Get the value of a variable stored on the obj
+PyObject *PyObj_getvar(PyObj *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Obj variables must have string names.");
+    return NULL;
+  }
+
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL) {
+    int vartype = objGetVarType(obj, var);
+    if(vartype == DYN_VAR_INT)
+      return Py_BuildValue("i", objGetInt(obj, var));
+    else if(vartype == DYN_VAR_LONG)
+      return Py_BuildValue("i", objGetLong(obj, var));
+    else if(vartype == DYN_VAR_DOUBLE)
+      return Py_BuildValue("d", objGetDouble(obj, var));
+    else
+      return Py_BuildValue("s", objGetString(obj, var));
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to get a variable value for nonexistant obj, %d",
+		 self->uid);
+    return NULL;
+  }
+}
+
+
+//
+// Set the value of a variable assocciated with the character
+PyObject *PyObj_setvar(PyObj *self, PyObject *args) {  
+  char     *var = NULL;
+  PyObject *val = NULL;
+
+  if (!PyArg_ParseTuple(args, "sO", &var, &val)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Obj setvar must be supplied with a var name and integer value.");
+    return NULL;
+  }
+
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL) {
+    if(PyInt_Check(val))
+      objSetInt(obj, var, (int)PyInt_AsLong(val));
+    else if(PyFloat_Check(val))
+      objSetDouble(obj, var, PyFloat_AsDouble(val));
+    else if(PyString_Check(val))
+      objSetString(obj, var, PyString_AsString(val));
+    else {
+      PyErr_Format(PyExc_TypeError,
+		   "Tried to store a obj_var of invalid type on obj %d.",
+		   self->uid);
+      return NULL;
+    }
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to set a variable value for nonexistant obj, %d",
+		 self->uid);
+    return NULL;
+  }
+}
+
+
 
 //*****************************************************************************
 // structures to define our methods and classes
@@ -1092,6 +1205,16 @@
 		    "adds an extra description to the object.");
     PyObj_addMethod("getAuxiliary", PyObj_get_auxiliary, METH_VARARGS,
 		    "get's the specified piece of aux data from the obj");
+    PyObj_addMethod("getvar", PyObj_getvar, METH_VARARGS,
+		    "get the value of a special variable the object has.");
+    PyObj_addMethod("setvar", PyObj_setvar, METH_VARARGS,
+		    "set the value of a special variable the object has.");
+    PyObj_addMethod("hasvar", PyObj_hasvar, METH_VARARGS,
+		    "return whether or not the object has a given variable.");
+    PyObj_addMethod("deletevar", PyObj_deletevar, METH_VARARGS,
+		    "delete a variable from the object's variable table.");
+    PyObj_addMethod("delvar", PyObj_deletevar, METH_VARARGS,
+		    "delete a variable from the object's variable table.");
 
     makePyType(&PyObj_Type, pyobj_getsetters, pyobj_methods);
     deleteListWith(pyobj_getsetters, free); pyobj_getsetters = NULL;
diff -ruN ../nakedmudv3.3/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv3.3/src/scripts/pyplugs.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pyplugs.c	2007-09-22 22:36:11.000000000 -0400
@@ -149,8 +149,8 @@
     int nlen = strlen(entry->d_name);
     sprintf(fname, "%s/%s", PYMOD_LIB, entry->d_name);
 
-    // skip ourself and our parent
-    if(!strcmp(entry->d_name, ".") || !strcmp(entry->d_name, ".."))
+    // skip hidden files, ourself, and our parent
+    if(*entry->d_name == '.')
       continue;
     // python file == module
     else if(nlen >= 4 && !strcasecmp(".py", entry->d_name + nlen-3)) {
diff -ruN ../nakedmudv3.3/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.3/src/scripts/pyroom.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/pyroom.c	2007-09-22 22:36:11.000000000 -0400
@@ -34,6 +34,13 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../dyn_vars/dyn_vars.h"
+
+
+
+//*****************************************************************************
 // local structures and defines
 //*****************************************************************************
 
@@ -74,7 +81,7 @@
     return -1;
   }
 
-  // make sure a room with the vnum exists
+  // make sure a room with the uid exists
   if(!propertyTableGet(room_table, uid)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Room with uid, %d, does not exist", uid);
@@ -94,6 +101,38 @@
     return 1;
 }
 
+long PyRoom_Hash(PyRoom *room) {
+  return room->uid;
+}
+
+
+
+//*****************************************************************************
+// methods in the room module
+//*****************************************************************************
+PyObject *PyRoom_get_room(PyObject *self, PyObject *args) {
+  char     *room_key = NULL;
+  ROOM_DATA    *room = NULL;
+  
+  if (!PyArg_ParseTuple(args, "s", &room_key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "get room failed - it needs a room key/locale.");
+    return NULL;
+  }
+
+  // try to find the room
+  room = worldGetRoom(gameworld, get_fullkey_relative(room_key, get_script_locale()));
+
+  if(room == NULL) {
+    PyErr_Format(PyExc_TypeError, "get room failed: room does not exist or "
+		 "is abstract.");
+    return NULL;
+  }
+
+  // create a python object for the new char, and return it
+  return Py_BuildValue("O", roomGetPyFormBorrowed(room));
+}
+
 
 
 //*****************************************************************************
@@ -673,6 +712,117 @@
 }
 
 
+//
+// Returns TRUE if the room has the given variable set
+PyObject *PyRoom_hasvar(PyRoom *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Room variables must have string names.");
+    return NULL;
+  }
+
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL)
+    return Py_BuildValue("b", roomHasVar(room, var));
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant room, %d",
+	       self->uid);
+  return NULL;
+}
+
+
+//
+// Delete the variable set on the room with the specified name
+PyObject *PyRoom_deletevar(PyRoom *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Room variables must have string names.");
+    return NULL;
+  }
+
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) {
+    roomDeleteVar(room, var);
+    return Py_BuildValue("i", 1);
+  }
+
+  PyErr_Format(PyExc_TypeError, 
+	       "Tried to get a variable value for nonexistant room, %d",
+	       self->uid);
+  return NULL;
+}
+
+
+//
+// Get the value of a variable stored on the room
+PyObject *PyRoom_getvar(PyRoom *self, PyObject *arg) {
+  char *var = NULL;
+  if (!PyArg_ParseTuple(arg, "s", &var)) {
+    PyErr_Format(PyExc_TypeError, 
+                    "Room variables must have string names.");
+    return NULL;
+  }
+
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) {
+    int vartype = roomGetVarType(room, var);
+    if(vartype == DYN_VAR_INT)
+      return Py_BuildValue("i", roomGetInt(room, var));
+    else if(vartype == DYN_VAR_LONG)
+      return Py_BuildValue("i", roomGetLong(room, var));
+    else if(vartype == DYN_VAR_DOUBLE)
+      return Py_BuildValue("d", roomGetDouble(room, var));
+    else
+      return Py_BuildValue("s", roomGetString(room, var));
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to get a variable value for nonexistant room, %d",
+		 self->uid);
+    return NULL;
+  }
+}
+
+
+//
+// Set the value of a variable assocciated with the character
+PyObject *PyRoom_setvar(PyRoom *self, PyObject *args) {  
+  char     *var = NULL;
+  PyObject *val = NULL;
+
+  if (!PyArg_ParseTuple(args, "sO", &var, &val)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Room setvar must be supplied with a var name and integer value.");
+    return NULL;
+  }
+
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room != NULL) {
+    if(PyInt_Check(val))
+      roomSetInt(room, var, (int)PyInt_AsLong(val));
+    else if(PyFloat_Check(val))
+      roomSetDouble(room, var, PyFloat_AsDouble(val));
+    else if(PyString_Check(val))
+      roomSetString(room, var, PyString_AsString(val));
+    else {
+      PyErr_Format(PyExc_TypeError,
+		   "Tried to store a room_var of invalid type on room %d.",
+		   self->uid);
+      return NULL;
+    }
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to set a variable value for nonexistant room, %d",
+		 self->uid);
+    return NULL;
+  }
+}
+
 
 
 //*****************************************************************************
@@ -693,7 +843,7 @@
     0,                         /*tp_as_number*/
     0,                         /*tp_as_sequence*/
     0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
+    (hashfunc)PyRoom_Hash,     /*tp_hash */
     0,                         /*tp_call*/
     0,                         /*tp_str*/
     0,                         /*tp_getattro*/
@@ -721,6 +871,8 @@
 };
 
 PyMethodDef room_module_methods[] = {
+  { "get_room", (PyCFunction)PyRoom_get_room, METH_NOARGS,
+    "Takes a room key/locale and returns a pointer to that room." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -807,6 +959,16 @@
 		     "returns whether or not the room inherits from the proto");
     PyRoom_addMethod("getAuxiliary", PyRoom_get_auxiliary, METH_VARARGS,
 		     "get's the specified piece of aux data from the room");
+    PyRoom_addMethod("getvar", PyRoom_getvar, METH_VARARGS,
+		    "get the value of a special variable the room has.");
+    PyRoom_addMethod("setvar", PyRoom_setvar, METH_VARARGS,
+		    "set the value of a special variable the room has.");
+    PyRoom_addMethod("hasvar", PyRoom_hasvar, METH_VARARGS,
+		    "return whether or not the room has a given variable.");
+    PyRoom_addMethod("deletevar", PyRoom_deletevar, METH_VARARGS,
+		    "delete a variable from the room's variable table.");
+    PyRoom_addMethod("delvar", PyRoom_deletevar, METH_VARARGS,
+		    "delete a variable from the room's variable table.");
 
     // add in all the getsetters and methods
     makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
diff -ruN ../nakedmudv3.3/src/scripts/scripts.c src/scripts/scripts.c
--- ../nakedmudv3.3/src/scripts/scripts.c	2006-12-24 22:15:56.000000000 -0500
+++ src/scripts/scripts.c	2007-09-22 22:36:11.000000000 -0400
@@ -70,7 +70,7 @@
   deleteListWith(data->triggers, free);
   if(data->pyform && data->pyform->ob_refcnt > 1)
     log_string("LEAK: Memory leak (%d refcnt) on someone or something's pyform",
-	       data->pyform->ob_refcnt);
+	       (int)data->pyform->ob_refcnt);
   Py_XDECREF(data->pyform);
   free(data);
 }
diff -ruN ../nakedmudv3.3/src/storage.c src/storage.c
--- ../nakedmudv3.3/src/storage.c	2006-12-24 22:15:56.000000000 -0500
+++ src/storage.c	2007-09-22 22:36:11.000000000 -0400
@@ -159,24 +159,28 @@
   fprintf(fl, fmt, key);
 }
 
-
 //
 // write a string containing newlines to a file
 //
 void write_string_data(const char *string, FILE *fl, int indent) {
   static char buf[SMALL_BUFFER];
-  int i, str_i;
+  int i, str_i, do_indent;
+  *buf = '\0';
+  do_indent = TRUE;
 
-  for(str_i = i = 0; string[str_i] != '\0'; str_i++) {
-    buf[i] = string[str_i];
-    if(buf[i] == '\n') {
-      buf[++i] = '\0';
-      print_indent(fl, indent);
+  for(i = str_i = 0; string[str_i] != '\0'; str_i++) {
+    buf[i++] = string[str_i];
+    if(i == SMALL_BUFFER-1 || string[str_i] == '\n') {
+      if(do_indent == TRUE) {
+	print_indent(fl, indent);
+	do_indent = FALSE;
+      }
+      buf[i] = '\0';
       fprintf(fl, "%s", buf);
       i = 0;
+      if(string[str_i] == '\n')
+	do_indent = TRUE;
     }
-    else
-      i++;
   }
 }
 
@@ -392,9 +396,31 @@
 // Read until we hit a newline. Return a copy of what we find
 //
 char *parse_line(FILE *fl) {
-  static char buf[SMALL_BUFFER];
-  fgetline(fl, buf, SMALL_BUFFER);
-  return strdup(buf);
+  static BUFFER *buf = NULL;
+  static char   sbuf[SMALL_BUFFER];
+  int              i = 0;
+  if(buf == NULL)
+    buf = newBuffer(1);
+  bufferClear(buf);
+  *sbuf = 0;
+
+  // fill up our small buffer to max, then copy it over
+  for(i = 0; (sbuf[i] = getc(fl)) != EOF && sbuf[i] != '\n';) {
+    if(i < SMALL_BUFFER-2)
+      i++;
+    else {
+      sbuf[++i] = '\0';
+      bprintf(buf, "%s", sbuf);
+      i = 0;
+      sbuf[i] = '\0';
+    }
+  }
+
+  // we found the newline
+  if(sbuf[i] == '\n')
+    sbuf[i] = '\0';
+  bprintf(buf, "%s", sbuf);
+  return strdup(bufferString(buf));
 }
 
 
@@ -402,20 +428,22 @@
 // read in a string that may possibly have multiple newlines in it
 //
 char *parse_string(FILE *fl, int indent) {
-  static char line[SMALL_BUFFER];
-  static char buf [MAX_BUFFER];
-  *buf = '\0';
-  int i = 0;
+  static BUFFER *buf = NULL;
+  char          *ptr = NULL;
+  if(buf == NULL)
+    buf = newBuffer(1);
+  bufferClear(buf);
 
   // as long as we can skip up our indent, we can read in data and
   // all is good. Once we can no longer skip up our indent, then
   // we have come to the end of our string
   while(skip_indent(fl, indent)) {
-    fgetline(fl, line, SMALL_BUFFER);
-    i += snprintf(buf+i, MAX_BUFFER-i-1, "%s\n", line);
+    ptr = parse_line(fl);
+    bprintf(buf, "%s\n", ptr);
+    free(ptr);
   }
 
-  return strdup(buf);
+  return strdup(bufferString(buf));
 }
 
 
diff -ruN ../nakedmudv3.3/src/time/mudtime.h src/time/mudtime.h
--- ../nakedmudv3.3/src/time/mudtime.h	2006-12-24 22:15:56.000000000 -0500
+++ src/time/mudtime.h	2007-09-22 22:36:11.000000000 -0400
@@ -58,15 +58,4 @@
 bool is_evening();
 bool is_night();
 
-
-//
-// If we have the time module installed, there is the option of
-// supplying a night description for the room, that will be shifted
-// to when it becomes evening/night time.
-//
-const char *roomGetNightDesc      (ROOM_DATA *room);
-BUFFER     *roomGetNightDescBuffer(ROOM_DATA *room);
-void        roomSetNightDesc      (ROOM_DATA *room, const char *desc);
-
-
 #endif // __MUDTIME_H
